<?php

namespace Repository;

use Util\InstanceProvider;
use Zeedhi\DevOps\Util\Utilities;
use Teknisa\Model\Traits\TQuery;

class CpCallOperador
{
    use TQuery;

    const CLASS_ENTITIES = '\Teknisa\Model\Teknisa\Entities\CpCallOperador';

    public function getEntityManager(){
        return InstanceProvider::getEntityManager();
    }

    public function findBy($filter){
        return InstanceProvider::getEntityManager()->getRepository(self::CLASS_ENTITIES)->findBy($filter);
    }

    public function findAllResponsibleIssue($issue)
    {
        $query = <<<SQL
         SELECT RT.EXTERNAL_CODE
				FROM TASK TAS
				JOIN PROJECT PRC ON(PRC.ID = TAS.PROJECT)
				JOIN RESOURCE_PROJECT RP ON RP.PROJECT = PRC.ID AND RP.TYPE = 'M'
				JOIN RESOURCE_T RT ON RT.ID = RP.RESOURCE_C
				WHERE TAS.ID = :ISSUE
SQL;

        $params = array(
            "ISSUE" => $issue,
        );
        $result =  $this->getEntityManager()->getConnection()->fetchAllAssociative($query, $params);
        return $result;
    }
    
    public function findVisualizedCallById($callId ,$cdoperadorCurrent)
    {

        $query = <<<SQL
         SELECT VISUALIZED_CALL, NRCALLOPERADOR
				FROM CP_CALL CALL
				JOIN CP_CALL_OPERADOR COW ON (COW.CDOPERADOR = '$cdoperadorCurrent' AND COW.NRCALL = CALL.NRCALL AND COW.TYPE = 'V')
				WHERE CALL.CALL_RELATIONSHIP = :CALL_RELATIONSHIP
SQL;

        $params = array(
            "CALL_RELATIONSHIP" => $callId,
        );
        $result =  $this->getEntityManager()->getConnection()->fetchAllAssociative($query, $params);
        return $result;
    }

}
