<?php
namespace Util\Instance;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Services\Repositories\FctOrcamento;
use Teknisa\Model\Teknisa\Repositories\CpCallAttachment;
use Teknisa\Model\Teknisa\Repositories\CpCallComment;
use Teknisa\Model\Teknisa\Repositories\Itemtarefa;
use Teknisa\Model\Teknisa\Repositories\Orcasolicita;
use Teknisa\Model\Teknisa\Repositories\Parcsoliserv;
use Teknisa\Model\Teknisa\Repositories\Tarefa;
use Util\Utilities;
use Zeedhi\DevOps\Model\Configurationmanager;
use Zeedhi\DevOps\Model\Servermanager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Util\InstanceProvider;
use \Zeedhi\DevOps\Model\Projectmanagement\Repositories;


class Repository {

    /** @return  Repository */
    public static function getInstance()
    {
        return new static();
    }

    /** @return  Repositories\Permission */
    public function getPermission()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Permission');
    }

    /** @return  Configurationmanager\Repositories\Release */
    public function getRelease()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::CONFIGURATION_ENTITY_DIR . 'Release');
    }

    /** @return  Configurationmanager\Repositories\Product */
    public function getProduct()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::CONFIGURATION_ENTITY_DIR . 'Product');
    }

    /** @return  Configurationmanager\Repositories\Subrelease */
    public function getSubrelease()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::CONFIGURATION_ENTITY_DIR . 'Subrelease');
    }

    /** @return  Configurationmanager\Repositories\Package */
    public function getPackage()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::CONFIGURATION_ENTITY_DIR . 'Package');
    }

    /** @return  Configurationmanager\Repositories\Package */
    public function getPackageContents()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::CONFIGURATION_ENTITY_DIR . 'PackageContents');
    }

    /** @return  Servermanager\Repositories\ProductServer */
    public function getProductServer()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::SERVER_ENTITY_DIR . 'ProductServer');
    }

    /** @return  Repositories\Directory */
    public function getDirectory()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Directory');
    }
    /** @return  Repositories\ProjectApproval */
    public function getProjectApproval()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'ProjectApproval');
    }

    /** @return  Repositories\Attachment */
    public function getAttachment()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Attachment');
    }

    /** @return  Repositories\Structure */
    public function getStructure()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Structure');
    }

    /** @return  Repositories\Resource */
    public function getResource()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Resource');
    }

    /** @return  Repositories\TaskTypeClassification */
    public function getTaskTypeClassification()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'TaskTypeClassification');
    }

    /** @return  Repositories\TaskType */
    public function getTaskType()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'TaskType');
    }

    /** @return  Repositories\ResourceProject */
    public function getResourceProject()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'ResourceProject');
    }

    /** @return  Repositories\Repository */
    public function getRepository()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Repository');
    }

    /** @return  Repositories\TaskProperties */
    public function getTaskProperties()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'TaskProperties');
    }

    /** @return  Repositories\ChangedFiles */
    public function getChangedFiles()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'ChangedFiles');
    }

    /** @return  Repositories\Organization */
    public function getOrganization()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Organization');
    }

    /** @return  Repositories\TaskLabel */
    public function getTaskLabel()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'TaskLabel');
    }

    /** @return  Repositories\Comments */
    public function getComments()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Comments');
    }

    /** @return CpCallComment */
    public function getCallComments()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'CpCallComment');
    }

    /** @return CpCallAttachment */
    public function getCallAttachment()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'CpCallAttachment');
    }

    /** @return  Repositories\Label */
    public function getLabel()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Label');
    }

    /** @return  Repositories\Task */
    public static function getTask()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Task');
    }
    /** @return  Repositories\Allocation */
    public function getAllocation()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Allocation');
    }
    /** @return  Repositories\BudgetPlots */
    public function getBudgetPlots()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'BudgetPlots');
    }

    /** @return  Repositories\BudgetItem */
    public function getBudgetItem()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'BudgetItem');
    }
    /** @return  Repositories\BudgetItemBudget */
    public function getBudgetItemBudget()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'BudgetItemBudget');
    }
    /** @return  Repositories\Budget */
    public static function getBudget()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Budget');
    }

    /** @return  Repositories\DocumentTemplate */
    public function getDocumentTemplate()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'DocumentTemplate');
    }
    /** @return  Repositories\ClassificationBudgetItem */
    public function getClassificationBudgetItem()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'ClassificationBudgetItem');
    }
    /** @return  Repositories\Classification */
    public function getClassification()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Classification');
    }

    /** @return  Repositories\TaskRelationship */
    public function getTaskRelationship()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'TaskRelationship');
    }

    /** @return  Tarefa */
    public function getTarefa()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Tarefa');
    }
    /** @return  \Teknisa\Model\Geral\Repositories\Novocodigo */
    public function getNovocodigo()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::GERAL_ENTITY_DIR . 'Novocodigo');
    }

    /** @return  Itemtarefa */
    public function getItemTarefa()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Itemtarefa');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Planativtare */
    public function getPlanativtare()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Planativtare');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Descplativ */
    public function getDescplativ()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Descplativ');
    }

    /** @return \Teknisa\Model\Teknisa\Repositories\Platvrelittr */
    public function getPlAtvRelItTr()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Platvrelittr');
    }

    /** @return  Repositories\CommentType */
    public function getCommentType()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'CommentType');
    }

    /** @return  Repositories\TaskTypeProjectType */
    public function getTaskTypeProjectType()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'TaskTypeProjectType');
    }

    /** @return  Repositories\ProjectType */
    public function getProjectType()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'ProjectType');
    }
    /** @return  Repositories\WorkedTime */
    public function getWorkedTime()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'WorkedTime');
    }
    /** @return  \Teknisa\Model\Geral\Repositories\Perfacessparc */
    public function getPerfacessparc()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Geral\Entities\Perfacessparc');
    }
    /** @return  \Teknisa\Model\Geral\Repositories\Perfilacesso */
    public function getPerfilacesso()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Geral\Entities\Perfilacesso');
    }

    /** @return  \Zeedhi\DevOps\Model\Projectmanagement\Repositories\Profile */
    public function getProfile()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Profile');
    }

    /** @return  Repositories\Rule */
    public function getRule()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'Rule');
    }

    /** @return  \Teknisa\Model\Teknisa\Repositories\CpCall  */
    public function getCpCall()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'CpCall');

    }

    /** @return  \Teknisa\Model\Teknisa\Repositories\getCpCallOperador  */
    public function getCpCallOperador()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'CpCallOperador');

    }
    /** @return  \Teknisa\Model\Teknisa\Repositories\Soliserv  */
    public function getSoliserv()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Soliserv');
    }
    /** @return  FctOrcamento */
    public function getFctOrcamento()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Services\Entities\FctOrcamento');
    }
    /** @return  \Teknisa\Model\Teknisa\Repositories\Descsoli  */
    public function getDescsoli()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::TEKNISA_ENTITY_DIR . 'Descsoli');
    }

    /** @return  \Teknisa\Model\Teknisa\Repositories\Licencauso */
    public function getLicencauso()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Teknisa\Entities\Licencauso');
    }

    /** @return  Repositories\PartnerProfile */
    public function getPartnerProfile()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'PartnerProfile');
    }

    /** @return  Repositories\TaskFeatures */
    public function getTaskFeatures()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskFeatures');
    }

    public function getErrorClassification()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\ErrorClassification');
    }

    public function getReplanningReason()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\ReplanningReason');
    }

    public function getTaskReplanningReason()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskReplanningReason');
    }

    /** @return  \Zeedhi\DevOps\Model\Projectmanagement\Repositories\Project */
    public function getProject()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Project');
    }

    /** @return  \Zeedhi\DevOps\Model\Projectmanagement\Repositories\TaskStatus */
    public static function getTaskStatus()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus');
    }

    public function getOperador()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Geral\Entities\Operador');
    }

    public function getOperadorAcesso()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Geral\Entities\c');
    }

    public function getCliente()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Geral\Entities\Cliente');
    }

    public function getCalendar()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar');
    }

    /** @return  \Zeedhi\DevOps\Model\Devops\Repositories\ProductVersion */
    public function getProductVersion()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Zeedhi\DevOps\Model\Devops\Entities\ProductVersion');
    }

     /** @return  Repositories\TaskBranchs */
    public function getTaskBranchs()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'TaskBranches');
    }

    /** @return  /** @return  \Zeedhi\DevOps\Model\Projectmanagement\Repositories\ProjectRelationship */
    public function getProjectRelationship()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'ProjectRelationship');
    }

    /** @return  /** @return  \Teknisa\Model\Teknisa\Repositories\OmProduto */
    public function getOmProduto()
    {
        return InstanceProvider::getEntityManager()->getRepository('Teknisa\Model\Teknisa\Entities\OmProduto');
    }

    /** @return Parcsoliserv */
    public function getParcsoliserv()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Teknisa\Entities\Parcsoliserv');
    }
    /** @return Orcasolicita  */
    public function getOrcasolicita()
    {
        return InstanceProvider::getEntityManager()->getRepository('\Teknisa\Model\Teknisa\Entities\Orcasolicita');
    }

    /** @return  /** @return  \Zeedhi\DevOps\Model\Projectmanagement\Repositories\ClassificationPerfilacesso */
    public function getClassificationPerfilacesso()
    {
        return InstanceProvider::getEntityManager()->getRepository(Utilities::ENTITY_DIR . 'ClassificationPerfilacesso');
    }

    /** @return  \Repository\CpCall  */
    public function getCpCallLocal()
    {
        return InstanceManager::getInstance()->getService('cpCallRepository');
    }

    /** @return  \Repository\Comments  */
    public function getCommentsLocal()
    {
        return InstanceManager::getInstance()->getService('commentsRepository');
    }

    /** @return  \Repository\Attachments  */
    public function getAttachmentsLocal()
    {
        return InstanceManager::getInstance()->getService('attachmentsRepository');
    }
    /** @return  \Repository\CpCallOperador  */
    public function getCpCallOperadorLocal()
    {
        return InstanceManager::getInstance()->getService('\Repository\CpCallOperador');
    }

    /** @return  \Repository\Soliserv  */
    public function getSoliservLocal()
    {
        return InstanceManager::getInstance()->getService('soliservRepository');
    }

    /** @return  \Repository\Structure*/
    public function getLocalStructure()
    {
        return InstanceManager::getInstance()->getService('\Repository\Structure');
    }

    /** @return  \Repository\Soliserv*/
    public function getLocalSoliserv()
    {
        return InstanceManager::getInstance()->getService('\Repository\Soliserv');
    }

    /** @return  \Repository\Project*/
    public function getLocalProject()
    {
        return InstanceManager::getInstance()->getService('\Repository\Project');
    }

    /** @return  \Repository\AclLabels*/
    public function getLocalAclLabels()
    {
        return InstanceManager::getInstance()->getService('\Repository\AclLabels');
    }

}
